#ifndef _INT64_H
#define _INT64_H

/* int64.h (fr)
   64 bit integer with Gnu C and MS VC
 */


/*
   defines type and some constants for 'portable' 64 bit ints:
   int64    is the (signed) type
   ONE64    is the 64-bit 1 (e.g. 2**60 : ONE64 << 60)
   FMT64    is the format spec (e.g. printf( "%20" FMT64 "d",...) )
   BYT64    is a byte of 1-bits (255) in 64-bit format
 */


#ifdef __GNUC__                        /* GNU CC */

typedef long long int64;
#define ONE64 1LL
#define FMT64 "ll"
#define BYT64 255LL

#endif 

#ifdef _MSC_VER                        /* MS Visual C */

typedef __int64 int64;
#define ONE64 1I64
#define FMT64 "I64"
#define BYT64 255I64

#endif 


#endif /* _INT64_H */

