#ifndef _NSTRING_H
#define _NSTRING_H
/*
   xbnfgen version 0.6  Copyright (C) 2007-2014 Frank Reglin

   xbnfgen is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   xbnfgen is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with xbnfgen; see the file COPYING.
*/

/* nstring.h
   routines for strings with explicite length
*/


typedef struct
{
   int len;
   char * str;
} NSTRING;

/* NSTRING as 2 parameters: */
#define nstring(pnst) ((pnst).len),((pnst).str)
/* example:  printf( " %.*s", nstring(ps) ); */


/* NSTRING assignment: */
#define nstring_assign(pnst,n,s) if(0); else { (pnst).len=(n); (pnst).str=(s); }


int nstrcmp( int s1len, char * s1, int s2len, char * s2 );
/* like strcmp but uses the given length.
   unsigned compare, null bytes are allowed */


int nstricmp( int s1len, char * s1, int s2len, char * s2 );
/* like stricmp but uses the given length.
   unsigned compare, null bytes are allowed */


/* if the 2nd string is zero terminated: */
int nstrcmp2z ( int s1len, char * s1, char * s2 );
int nstricmp2z( int s1len, char * s1, char * s2 );


#endif /* _NSTRING_H */
