/*
   xbnfgen version 0.6  Copyright (C) 2007-2014 Frank Reglin

   xbnfgen is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   xbnfgen is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with xbnfgen; see the file COPYING.
*/


#include <fcntl.h>
#include <malloc.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "port.h"
#include "sutil.h"
#include "salloc.h"

#include "mfatal.h" /* needed for MFATAL message */

#define  STRMAX  100000



void * salloc( int size )
/* ================================================================ */
/* valid pointer is guaranteed, the contents is initialized w 0
   otherwise a fatal error is issued.
*/
{
void * ptr;

   if( size <= 0 )
      return 0;

   ptr = MYMALLOC( size );
   if( !ptr )
   {
      MFATAL( "Not enough memory", strf("trying to allocate %d bytes\n",size) );
      /* should never return, but just to make sure: */
      exit( 9 );
   }
   memset( ptr, 0, size );

   return ptr;
}


