#ifndef _SALLOC_H
#define _SALLOC_H
/*
   xbnfgen version 0.6  Copyright (C) 2007-2014 Frank Reglin

   xbnfgen is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   xbnfgen is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with xbnfgen; see the file COPYING.
*/

// Attention: call sallocinit() once in your main() !!

/*
   salloc benutzt 3 Makros:
      MYMALLOC
      MYFREE
      MYMALLOCINIT
   Hier eigenes Memorymanagement einhaengen.
   Standard :
      MYMALLOC     --> malloc
      MYFREE       --> free
      MYMALLOCINIT --> Nix
   Es kann auch ein "statisches" Modell verwendet werden:
   MYMALLOCINIT : initialisiert ein hinreichedn grosses Array als "Heap"
   MYMALLOC : gibt immer den naechsten Teil dieses Arrays zurueck
   MYFREE   : macht nichts, ausser wenn mit der Adresse des letzten MYMALLOC
              aufgerufen, dann Arraypointer um diesen einen Block zurueck-
              setzen (Laenge am Anfang des freien Arrayb-Bereiches merken)
*/

#include "mymalloc.h"


void * salloc( int size );
/* valid pointer is guaranteed, the contents is initialized w 0
   otherwise a fatal error is issued.
*/

#define sfree      MYFREE
#define sallocinit MYMALLOCINIT

#endif /* _SALLOC_H */

