#  xbnfgen version 0.6  Copyright (C) 2007-2015 Frank Reglin
#
#  xbnfgen is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  xbnfgen is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#  See the GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with xbnfgen; see the file COPYING.

# xbnf makefile, gnumake
# LINUX
EXE=
OBJ=o

ifeq "$(DEBUG)" ""
	DEBUG=0
endif

# settings for Linux gcc 4.6.2
COMMCFLAGS=-c -Wall -DLINUX -Ilib
COMMLFLAGS=-lm

ifeq ($(DEBUG),0)
	# release settings
	OUTDIR=binx
	OBJDIR=objx
	CFLAGS=$(COMMCFLAGS) -O3
	LFLAGS=$(COMMLFLAGS)
else
	# debug settings
	OUTDIR=binx/debug
	OBJDIR=objx/debug
	CFLAGS=$(COMMCFLAGS) -g
	LFLAGS=$(COMMLFLAGS) -g
endif

CP=cp

CC=gcc $(CFLAGS)
CCR= $(CC) -o$@ $<
LOUT=-o
LINK=gcc $(LFLAGS)
LINKR=$(LINK) $(LOUT)$@ $^


include makefile.src


clean:
	-rm -f -r objx
	-rm -f src/xbnfparse.c src/xbnfsymbols.h
	-rm -f tst_*


# automatic dependency generation
# can use wildcards for all existing C files
# add generated files explicitely
ifneq ($(MAKECMDGOALS),clean)
$(OBJDIR)/depend.mk: src/*.c  src/xbnfparse.c
	touch $@
	makedepend -f$@ -p$(OBJDIR)/ -Y $(CFLAGS) $^

-include $(OBJDIR)/depend.mk
endif
# # #

