#ifndef _STACK_H
#define _STACK_H

/* stack.h (fr) 2007-2015
   simple stack

   elements are void ptr, assumingly dynamically allocated
*/

typedef void * VOIDPTR;


typedef struct
{
   int size;            /* real size of the array     */
   int tos;             /* current top of stack index */
   VOIDPTR * parray;    /* pointer to the array       */
} STACK;


STACK * stk_create( void );
/* creates an empty stack and returns it,
   or 0 if error */


int stk_push( STACK * pstk, void * val );
/* pushes val to the given stack, returns TOS (or < 0 for error) */


void * stk_pop( STACK * pstk );
/* pops the value at TOS and returns it (0 for errors) */


int stk_settop( STACK * pstk, int top );
/* if top < TOS -> sets TOS = top, otherwise no change, top >= -1,
   de-allcates all elements in between
   returns TOS (< 0 for errors */


/* the remaining 2 functions are implemented as macro: */

#define stk_gettop(pstk) ((pstk)?(pstk)->tos:-1)
/* gives TOS */

#define stk_get(pstk,index) ((pstk)->parray[index])
/* gives the value at index */


#endif /* _STACK_H */

